//
// This code was generated by Enunciate.
// http://enunciate.codehaus.org/
//
#include <libxml/xmlwriter.h>
#include <libxml/xmlreader.h>
#include <Foundation/Foundation.h>

#ifndef DEBUG_ENUNCIATE
//turn off enunciate debugging.
#define DEBUG_ENUNCIATE 0
#endif

/**
 * Enunciate-specific interfaces and protocols.
 */
#ifndef ENUNCIATE_OBJC_TYPES
#define ENUNCIATE_OBJC_TYPES

/**
 * Protocol defining an Enunciate XML I/O methods.
 */
@protocol EnunciateXML

/**
 * Read an instance from XML.
 *
 * @param xml The XML to read.
 */
+ (id<EnunciateXML>) readFromXML: (NSData *) xml;

/**
 * Write this instance as XML.
 *
 * @return The XML.
 */
- (NSData *) writeToXML;

@end /*protocol EnunciateXML*/


/**
 * A basic XML node. Can be an element or an attribute. Used
 * instead of NSXMLElement because it's not supported on all
 * platforms yet.
 */
@interface JAXBBasicXMLNode : NSObject
{
  @private
    NSString *_name;
    NSString *_ns;
    NSString *_prefix;
    NSString *_value;
    NSArray  *_childElements;
    NSArray  *_attributes;
}

/**
 * Accessor for the (local) name of the XML node.
 *
 * @return The (local) name of the XML node.
 */
- (NSString *) name;

/**
 * Accessor for the (local) name of the XML node.
 *
 * @param newName The (local) name of the XML node.
 */
- (void) setName: (NSString *) newName;

/**
 * Accessor for the namespace of the XML node.
 *
 * @return The namespace of the XML node.
 */
- (NSString *) ns;

/**
 * Accessor for the namespace of the XML node.
 *
 * @param newNs The namespace of the XML node.
 */
- (void) setNs: (NSString *) newNs;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @return The namespace prefix of the XML node.
 */
- (NSString *) prefix;

/**
 * Accessor for the namespace prefix of the XML node.
 *
 * @param newPrefix The namespace prefix of the XML node.
 */
- (void) setPrefix: (NSString *) newPrefix;

/**
 * Accessor for the value of the XML node.
 *
 * @return The value of the XML node.
 */
- (NSString *) value;

/**
 * Accessor for the value of the XML node.
 *
 * @param newValue The value of the XML node.
 */
- (void) setValue: (NSString *) newValue;

/**
 * Accessor for the child elements of the XML node.
 *
 * @return The child elements of the XML node.
 */
- (NSArray *) childElements;

/**
 * Accessor for the child elements of the XML node.
 *
 * @param newValue The child elements of the XML node.
 */
- (void) setChildElements: (NSArray *) newChildElements;

/**
 * Accessor for the attributes of the XML node.
 *
 * @return The attributes of the XML node.
 */
- (NSArray *) attributes;

/**
 * Accessor for the attributes of the XML node.
 *
 * @param newAttributes The attributes of the XML node.
 */
- (void) setAttributes: (NSArray *) newAttributes;
@end /*interface JAXBBasicXMLNode*/

#endif /* ENUNCIATE_OBJC_TYPES */


@class NEXUS_INDEXER_LUCENE_REST_APINS0NexusResponse;
@class NEXUS_INDEXER_LUCENE_REST_APINS0NexusArtifact;
@class NEXUS_INDEXER_LUCENE_REST_APINS0SearchResponse;

#ifndef DEF_NEXUS_INDEXER_LUCENE_REST_APINS0NexusResponse_H
#define DEF_NEXUS_INDEXER_LUCENE_REST_APINS0NexusResponse_H

/**
 *  Class NexusResponse.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_INDEXER_LUCENE_REST_APINS0NexusResponse : NSObject
{
  @private
}
@end /* interface NEXUS_INDEXER_LUCENE_REST_APINS0NexusResponse */

#endif /* DEF_NEXUS_INDEXER_LUCENE_REST_APINS0NexusResponse_H */
#ifndef DEF_NEXUS_INDEXER_LUCENE_REST_APINS0NexusArtifact_H
#define DEF_NEXUS_INDEXER_LUCENE_REST_APINS0NexusArtifact_H

/**
 *  Artifact details sent back on search requests.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_INDEXER_LUCENE_REST_APINS0NexusArtifact : NSObject
{
  @private
    NSString *_resourceURI;
    NSString *_groupId;
    NSString *_artifactId;
    NSString *_version;
    NSString *_classifier;
    NSString *_packaging;
    NSString *_extension;
    NSString *_repoId;
    NSString *_contextId;
    NSString *_pomLink;
    NSString *_artifactLink;
}

/**
 * The URL that can be used to retrieve the artifact.
 */
- (NSString *) resourceURI;

/**
 * The URL that can be used to retrieve the artifact.
 */
- (void) setResourceURI: (NSString *) newResourceURI;

/**
 * The group id of the artifact.
 */
- (NSString *) groupId;

/**
 * The group id of the artifact.
 */
- (void) setGroupId: (NSString *) newGroupId;

/**
 * The artifact id of the artifact.
 */
- (NSString *) artifactId;

/**
 * The artifact id of the artifact.
 */
- (void) setArtifactId: (NSString *) newArtifactId;

/**
 * The version of the artifact.
 */
- (NSString *) version;

/**
 * The version of the artifact.
 */
- (void) setVersion: (NSString *) newVersion;

/**
 * The classifier of the artifact.
 */
- (NSString *) classifier;

/**
 * The classifier of the artifact.
 */
- (void) setClassifier: (NSString *) newClassifier;

/**
 * The packaging of the artifact.
 */
- (NSString *) packaging;

/**
 * The packaging of the artifact.
 */
- (void) setPackaging: (NSString *) newPackaging;

/**
 * The extension of the artifact.
 */
- (NSString *) extension;

/**
 * The extension of the artifact.
 */
- (void) setExtension: (NSString *) newExtension;

/**
 * The repository id where the artifact is stored.
 */
- (NSString *) repoId;

/**
 * The repository id where the artifact is stored.
 */
- (void) setRepoId: (NSString *) newRepoId;

/**
 * The indexing context where the artifact is indexed.
 */
- (NSString *) contextId;

/**
 * The indexing context where the artifact is indexed.
 */
- (void) setContextId: (NSString *) newContextId;

/**
 * URL that would give you the pom file.
 */
- (NSString *) pomLink;

/**
 * URL that would give you the pom file.
 */
- (void) setPomLink: (NSString *) newPomLink;

/**
 * URL that would give you the artifact file.
 */
- (NSString *) artifactLink;

/**
 * URL that would give you the artifact file.
 */
- (void) setArtifactLink: (NSString *) newArtifactLink;
@end /* interface NEXUS_INDEXER_LUCENE_REST_APINS0NexusArtifact */

#endif /* DEF_NEXUS_INDEXER_LUCENE_REST_APINS0NexusArtifact_H */
#ifndef DEF_NEXUS_INDEXER_LUCENE_REST_APINS0SearchResponse_H
#define DEF_NEXUS_INDEXER_LUCENE_REST_APINS0SearchResponse_H

/**
 *  REST Response object for a list of search results, contains the
 typical 'data' parameter, which is a list of search results.
 
 @version $Revision$ $Date$

 */
@interface NEXUS_INDEXER_LUCENE_REST_APINS0SearchResponse : NEXUS_INDEXER_LUCENE_REST_APINS0NexusResponse <EnunciateXML>
{
  @private
    int _totalCount;
    int _from;
    int _count;
    BOOL _tooManyResults;
    NSArray *_data;
}

/**
 * The total number of results.
 */
- (int) totalCount;

/**
 * The total number of results.
 */
- (void) setTotalCount: (int) newTotalCount;

/**
 * The starting index of the results.
 */
- (int) from;

/**
 * The starting index of the results.
 */
- (void) setFrom: (int) newFrom;

/**
 * The number of results in this response.
 */
- (int) count;

/**
 * The number of results in this response.
 */
- (void) setCount: (int) newCount;

/**
 * Flag that states if too many results were found.
 */
- (BOOL) tooManyResults;

/**
 * Flag that states if too many results were found.
 */
- (void) setTooManyResults: (BOOL) newTooManyResults;

/**
 * Field data.
 */
- (NSArray *) data;

/**
 * Field data.
 */
- (void) setData: (NSArray *) newData;
@end /* interface NEXUS_INDEXER_LUCENE_REST_APINS0SearchResponse */

#endif /* DEF_NEXUS_INDEXER_LUCENE_REST_APINS0SearchResponse_H */
